/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public License
 * as published by the Free Software Foundation; either version 2.1
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 */

#include "./metadata.hpp"

namespace sh4lt {

bool Metadata::has_update(void* data, size_t size) {
  return reinterpret_cast<Metadata*>(static_cast<char*>(data) + size)->is_dirty;
}

size_t Metadata::get_size(void* data, size_t size) {
  return reinterpret_cast<Metadata*>(static_cast<char*>(data) + size)->size;
}

void* Metadata::get_mem(void* data, size_t size) {
  return (0 == Metadata::get_size(data, size)) ? nullptr
                                               : static_cast<char*>(data) + size + sizeof(Metadata);
}
}  // namespace sh4lt
